#include <iostream>
#include <type_traits>

template <typename Base, typename Derived>
void check_inheritance() {
    static_assert(std::is_base_of<Base, Derived>::value, 
                  "Derived must inherit from Base");
    std::cout << "Inheritance relationship verified." << std::endl;
}

class Animal {};
class Dog : public Animal {};
class Cat : public Animal {};
class Plant {};

int main() {
    check_inheritance<Animal, Dog>();
    check_inheritance<Animal, Cat>();
    // Uncommenting the next line would result in a compile-time error
    // check_inheritance<Animal, Plant>();
    return 0;
}
